package main

import (
	"context"
	"gitea.pena/SQuiz/storer/internal/app"
	"gitea.pena/SQuiz/storer/internal/initialize"
	"go.uber.org/zap"
	"log"
	"os/signal"
	"syscall"
	_ "gitea.pena/PenaSide/linters-golang/pkg/dummy"
)

func main() {
	config, err := initialize.LoadConfig()
	if err != nil {
		log.Fatal("Failed to load config", zap.Error(err))
	}

	ctx, stop := signal.NotifyContext(context.Background(), syscall.SIGINT, syscall.SIGTERM)
	defer stop()

	if err = app.Run(ctx, *config); err != nil {
		log.Fatal("App exited with error", zap.Error(err))
	}
}
