package initialize

import (
	"github.com/caarlos0/env/v8"
	"github.com/joho/godotenv"
	"log"
)

type Config struct {
	LoggerProdMode bool   `env:"IS_PROD_LOG" default:"false"`
	IsProd         bool   `env:"IS_PROD" default:"false"`
	S3Endpoint     string `env:"S3_ENDPOINT" envDefault:"localhost:9001"`
	S3AccessKey    string `env:"S3_ACCESS_KEY" envDefault:"admin"`
	S3SecretKey    string `env:"S3_SECRET_KEY" envDefault:"admin123"`
	ClientHttpURL  string `env:"CLIENT_HTTP_URL" envDefault:"0.0.0.0:1489"`
	CrtFile        string `env:"CRT" default:"server.crt"`
	KeyFile        string `env:"KEY" default:"server.key"`
	PostgresURL    string `env:"POSTGRES_URL" envDefault:"host=localhost port=35432 user=squiz password=Redalert2 dbname=squiz sslmode=disable"`
}

func LoadConfig() (*Config, error) {
	if err := godotenv.Load(); err != nil {
		log.Print("No .env file found")
	}
	var config Config
	if err := env.Parse(&config); err != nil {
		return nil, err
	}
	return &config, nil
}
