package initialize

import (
	"context"
	"gitea.pena/SQuiz/common/dal"
	"gitea.pena/SQuiz/storer/internal/repository"
	"github.com/minio/minio-go/v7"
)

type DALs struct {
	PgDAL *dal.DAL
	StDal *repository.S3
}

func NewDALs(ctx context.Context, cfg Config, minioClient *minio.Client) (*DALs, error) {
	pgDal, err := dal.New(ctx, cfg.PostgresURL, nil)
	if err != nil {
		return nil, err
	}

	stDal, err := repository.New(ctx, minioClient)
	if err != nil {
		return nil, err
	}

	return &DALs{
		PgDAL: pgDal,
		StDal: stDal,
	}, nil
}
